//+------------------------------------------------------------------+
//|                                                   Big Dog 10.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
extern int MaxRisk=2;
extern int TakeProfit=100;
extern int StopLoss=100;
extern int HourA=7;
extern int HourB=9;
extern int HourC=19;
extern double Level_1=0.0;
extern double Level_2=1.0;
extern double Level_3=1.272;
extern double Level_4=1.500;
extern double Level_5=1.764;
extern double Level_6=2.0;

int
   tic,
   i, 
   FLAG,
   KVADRAT,
   GRAN;
   
    
double
   Pr_Procrnt,
   Pr_Level_3a,
   Pr_Level_4a,
   Pr_Level_5a,
   Pr_Level_6a,
   Pr_Level_3b,
   Pr_Level_4b,
   Pr_Level_5b,
   Pr_Level_6b,
   MAX,
   MIN, 
   Lot;  

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

string 
   Opis_1=Level_1,
   Opis_2=Level_2,
   Opis_3=Level_3,
   Opis_4=Level_4,
   Opis_5=Level_5,
   Opis_6=Level_6;
 
if(Hour()==HourA && Minute()==0 && Seconds()==0)
  {
   datetime time_1=TimeCurrent();
   ObjectsDeleteAll(0,-1); 
   ObjectCreate("vline_1",OBJ_VLINE,0,TimeCurrent(),0);
  }
  
if(Hour()==HourB && Minute()==0 && Seconds()==0)
  {
   datetime time_2=TimeCurrent();  
   ObjectCreate("vline_2",OBJ_VLINE,0,TimeCurrent(),0);
   GRAN=1;
  }

if(GRAN==1)
  {
  MAX=High[iHighest(NULL,0,MODE_HIGH,9,0)];
  MIN=Low[iLowest(NULL,0,MODE_LOW,9,0)];
  ObjectCreate("hline_1",OBJ_HLINE,0,0,MAX); 
  ObjectCreate("hline_2",OBJ_HLINE,0,0,MIN);
  int
   price_1=MIN, 
   price_2=MAX;
   
//----  Fibo_1:   
  if(!ObjectCreate("Fibo_1",OBJ_FIBO,0,time_1,price_1,time_2,price_2))
    {
    Print("ObjectCreate(Fibo_1)  : ",GetLastError());
    }
  ObjectSet("Fibo_1",OBJPROP_COLOR,DeepPink);
  ObjectSet("Fibo_1",OBJPROP_FIBOLEVELS,6);
  ObjectSet("Fibo_1",OBJPROP_FIRSTLEVEL+0,Level_1); ObjectSetFiboDescription("Fibo_1",OBJPROP_FIRSTLEVEL+0,Opis_1); 
  ObjectSet("Fibo_1",OBJPROP_FIRSTLEVEL+1,Level_2); ObjectSetFiboDescription("Fibo_1",OBJPROP_FIRSTLEVEL+1,Opis_2); 
  ObjectSet("Fibo_1",OBJPROP_FIRSTLEVEL+2,Level_3); ObjectSetFiboDescription("Fibo_1",OBJPROP_FIRSTLEVEL+2,Opis_3); 
  ObjectSet("Fibo_1",OBJPROP_FIRSTLEVEL+3,Level_4); ObjectSetFiboDescription("Fibo_1",OBJPROP_FIRSTLEVEL+3,Opis_4); 
  ObjectSet("Fibo_1",OBJPROP_FIRSTLEVEL+4,Level_5); ObjectSetFiboDescription("Fibo_1",OBJPROP_FIRSTLEVEL+4,Opis_5); 
  ObjectSet("Fibo_1",OBJPROP_FIRSTLEVEL+5,Level_6); ObjectSetFiboDescription("Fibo_1",OBJPROP_FIRSTLEVEL+5,Opis_6); 
  Pr_Procrnt=NormalizeDouble((price_1-price_2)/100,Digits);
  Pr_Level_3a=(Level_3-Level_2)*100*Pr_Procrnt+price_1;
  Pr_Level_4a=(Level_4-Level_3)*100*Pr_Procrnt+Pr_Level_4a;
  Pr_Level_5a=(Level_5-Level_4)*100*Pr_Procrnt+Pr_Level_5a;
  Pr_Level_6a=(Level_6-Level_5)*100*Pr_Procrnt+Pr_Level_6a;
  
//----  Fibo_2:  
  if(!ObjectCreate("Fibo_2",OBJ_FIBO,0,time_2,price_2,time_1,price_1))
    {
    Print("ObjectCreate(Fibo_2)  : ",GetLastError());
    }
  ObjectSet("Fibo_2",OBJPROP_COLOR,DeepPink);
  ObjectSet("Fibo_2",OBJPROP_FIBOLEVELS,6);
  ObjectSet("Fibo_2",OBJPROP_FIRSTLEVEL+0,Level_1); ObjectSetFiboDescription("Fibo_2",OBJPROP_FIRSTLEVEL+0,Opis_1); 
  ObjectSet("Fibo_2",OBJPROP_FIRSTLEVEL+1,Level_2); ObjectSetFiboDescription("Fibo_2",OBJPROP_FIRSTLEVEL+1,Opis_2); 
  ObjectSet("Fibo_2",OBJPROP_FIRSTLEVEL+2,Level_3); ObjectSetFiboDescription("Fibo_2",OBJPROP_FIRSTLEVEL+2,Opis_3); 
  ObjectSet("Fibo_2",OBJPROP_FIRSTLEVEL+3,Level_4); ObjectSetFiboDescription("Fibo_2",OBJPROP_FIRSTLEVEL+3,Opis_4); 
  ObjectSet("Fibo_2",OBJPROP_FIRSTLEVEL+4,Level_5); ObjectSetFiboDescription("Fibo_2",OBJPROP_FIRSTLEVEL+4,Opis_5); 
  ObjectSet("Fibo_2",OBJPROP_FIRSTLEVEL+5,Level_6); ObjectSetFiboDescription("Fibo_2",OBJPROP_FIRSTLEVEL+5,Opis_6); 
  Pr_Level_3b=price_1-(Level_3-Level_2)*100*Pr_Procrnt;
  Pr_Level_4b=Pr_Level_4b-(Level_4-Level_3)*100*Pr_Procrnt;
  Pr_Level_5b=Pr_Level_5b-(Level_5-Level_4)*100*Pr_Procrnt;
  Pr_Level_6b=Pr_Level_6b-(Level_6-Level_5)*100*Pr_Procrnt;
  
  GRAN=0;
  KVADRAT=1;
  }
  
if(KVADRAT==1)
  {
  double Lot=GetLot(MaxRisk);
  NewOrder(OP_BUYSTOP, Lot, TakeProfit, StopLoss, MAX);
  NewOrder(OP_SELLSTOP, Lot, TakeProfit, StopLoss, MIN);
  KVADRAT=0;
  }
  
if(Hour()==HourC && Minute()==0 && Seconds()==0)
   yDeleteOrder();
  
return(0);
 }
//----------------------------------------------------------------------
//----------------------   -----------------------------
//----------------------------------------------------------------------  


//+---------  ---------------------------------------+
double GetLot(int Risk)
{
 double Free=AccountFreeMargin();
 double One_Lot=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step=MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lot=MathFloor(Free*Risk/100/One_Lot/Step)*Step;
 if(Lot<Min_Lot)Lot=Min_Lot;
 if(Lot>Max_Lot)Lot=Max_Lot;
 if(Lot*One_Lot>Free)return(0.0);
 return(Lot);
}

//+----------  -----------------------------------+
int NewOrder(int Cmd,double Lot,int TaPr,int StLo,double Otkr)
{
 double TP=0;// 
 double SL=0;// 
 double PR=0;// 
 while(!IsTradeAllowed())Sleep(100);
 if(TaPr<MarketInfo(Symbol(),MODE_STOPLEVEL))  
    TaPr=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(StLo<MarketInfo(Symbol(),MODE_STOPLEVEL))  
    StLo=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(Cmd==OP_BUYSTOP)
   {
    PR=NormalizeDouble(Otkr, Digits);
    if(TaPr>0)TP=NormalizeDouble(Otkr,Digits)+NormalizeDouble(TaPr*Point,Digits);
    if(StLo>0)SL=NormalizeDouble(Otkr,Digits)-NormalizeDouble(StLo*Point,Digits);
   }
 if(Cmd==OP_SELLSTOP)
   {
    PR=NormalizeDouble(Otkr, Digits);
    if(TaPr>0)TP=NormalizeDouble(Otkr,Digits)-NormalizeDouble(TaPr*Point,Digits);
    if(StLo>0)SL=NormalizeDouble(Otkr,Digits)+NormalizeDouble(StLo*Point,Digits);
   }
 Print("TaPr=",TaPr," StLo=",StLo," StopLevel=",MarketInfo(Symbol(),MODE_STOPLEVEL));
 tic=OrderSend(Symbol(),Cmd,Lot,PR,3,SL,TP,"",0,0,CLR_NONE);
 if(tic<0)Print("  :",GetLastError()); Print("Cmd-",Cmd," Lot=",Lot," PR=",PR," SL=",SL," TP=",TP);
return(tic);
}

//+-----------   ----------------------------------+
int yDeleteOrder()
{
   for(int i=1; i<=OrdersTotal(); i++)
      {
         if(OrderSelect(i-1,SELECT_BY_POS)==true)
            {
               if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
                     OrderDelete(OrderTicket());
            }
         else
            Print("OrderSelect()   - ",GetLastError());
      }
   return(0);
} 
 
 
 
 
 
 
 
 
 
 
 
 
 
   
//----
  
//+------------------------------------------------------------------+